karaf-issues mailing list archives

Site index · List index
Message view « Date » · « Thread »
Top « Date » · « Thread »
From "Guillaume Nodet (JIRA)" <j...@apache.org>
Subject [jira] [Commented] (KARAF-4302) Features file not working when protocol wrap required
Date Fri, 19 Feb 2016 09:39:18 GMT

    [ https://issues.apache.org/jira/browse/KARAF-4302?page=com.atlassian.jira.plugin.system.issuetabpanels:comment-tabpanel&focusedCommentId=15153982#comment-15153982
] 

Guillaume Nodet commented on KARAF-4302:
----------------------------------------

You need to do the following:
{code}
featuresBoot = \
    (instance, \
      package, \
      log, \
      ssh, \
      system, \
      feature, \
      shell, \
      management, \
      service, \
      jaas, \
      deployer, \
      diagnostic, \
      bundle, \
      config, \
      kar, 
      wrap), \
    (camel-geocoded)
{code}

This will perform a two-step installation of features, the first set containing all but camel-geocoded,
the second set containing the camel-geocoded feature.

This will ensure that the wrap feature will be installed, before camel-geocoded is installed.

Another (better) way would be to enhance the camel features to use a prerequisite="true" flag
when features use the wrap protocol.

> Features file not working when protocol wrap required
> -----------------------------------------------------
>
>                 Key: KARAF-4302
>                 URL: https://issues.apache.org/jira/browse/KARAF-4302
>             Project: Karaf
>          Issue Type: Bug
>          Components: karaf-core, karaf-feature
>    Affects Versions: 4.0.4
>         Environment: Karaf 4.0.4, Java 1.8
>            Reporter: Mariano Gonzalez
>            Assignee: Jean-Baptiste Onofré
>            Priority: Blocker
>
> Using a fresh karaf installation with the following configuration {{org.apache.karaf.features.cfg}}
file:
> {code}
> #
> # Comma separated list of features repositories to register by default
> #
> featuresRepositories = \
>     mvn:org.apache.karaf.features/spring/4.0.4/xml/features, \
>     mvn:org.apache.karaf.features/standard/4.0.4/xml/features, \
>     mvn:org.apache.karaf.features/framework/4.0.4/xml/features, \
>     mvn:org.apache.karaf.features/enterprise/4.0.4/xml/features, \
>     mvn:org.apache.activemq/activemq-karaf/5.12.1/xml/features-core, \
>     mvn:org.apache.camel.karaf/apache-camel/2.16.1/xml/features, \
>     mvn:io.hawt/hawtio-karaf/2.0.0/xml/features
> #
> # Comma separated list of features to install at startup
> #
> featuresBoot = \
>     instance, \
>     package, \
>     log, \
>     ssh, \
>     aries-blueprint, \
>     system, \
>     feature, \
>     shell, \
>     management, \
>     service, \
>     jaas, \
>     shell-compat, \
>     deployer, \
>     diagnostic, \
>     wrap, \
>     camel-geocoder
> {code}
> I get the following exception:
> {code:java}
> Error installing boot features
> org.apache.karaf.features.internal.util.MultiException: Error
> 	at org.apache.karaf.features.internal.download.impl.MavenDownloadManager$MavenDownloader.<init>(MavenDownloadManager.java:84)[9:org.apache.karaf.features.core:4.0.4]
> 	at org.apache.karaf.features.internal.download.impl.MavenDownloadManager.createDownloader(MavenDownloadManager.java:72)[9:org.apache.karaf.features.core:4.0.4]
> 	at org.apache.karaf.features.internal.region.Subsystem.downloadBundles(Subsystem.java:363)[9:org.apache.karaf.features.core:4.0.4]
> 	at org.apache.karaf.features.internal.region.Subsystem.downloadBundles(Subsystem.java:360)[9:org.apache.karaf.features.core:4.0.4]
> 	at org.apache.karaf.features.internal.region.SubsystemResolver.resolve(SubsystemResolver.java:187)[9:org.apache.karaf.features.core:4.0.4]
> 	at org.apache.karaf.features.internal.service.Deployer.deploy(Deployer.java:263)[9:org.apache.karaf.features.core:4.0.4]
> 	at org.apache.karaf.features.internal.service.FeaturesServiceImpl.doProvision(FeaturesServiceImpl.java:1089)[9:org.apache.karaf.features.core:4.0.4]
> 	at org.apache.karaf.features.internal.service.FeaturesServiceImpl$1.call(FeaturesServiceImpl.java:985)[9:org.apache.karaf.features.core:4.0.4]
> 	at java.util.concurrent.FutureTask.run(FutureTask.java:266)[:1.8.0_66]
> 	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)[:1.8.0_66]
> 	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)[:1.8.0_66]
> 	at java.lang.Thread.run(Thread.java:745)[:1.8.0_66]
> Caused by: java.io.IOException: Error downloading wrap:file:/Users/magonzal/.m2/repository/com/google/code/geocoder-java/geocoder-java/0.16/geocoder-java-0.16.jar
> 	at org.apache.karaf.features.internal.download.impl.AbstractRetryableDownloadTask.run(AbstractRetryableDownloadTask.java:67)[9:org.apache.karaf.features.core:4.0.4]
> 	at java.util.concurrent.Executors$RunnableAdapter.call(Executors.java:511)[:1.8.0_66]
> 	at java.util.concurrent.FutureTask.run(FutureTask.java:266)[:1.8.0_66]
> 	at java.util.concurrent.ScheduledThreadPoolExecutor$ScheduledFutureTask.access$201(ScheduledThreadPoolExecutor.java:180)[:1.8.0_66]
> 	at java.util.concurrent.ScheduledThreadPoolExecutor$ScheduledFutureTask.run(ScheduledThreadPoolExecutor.java:293)[:1.8.0_66]
> 	... 3 more
> Caused by: java.io.IOException: Could not download [wrap:file:/Users/magonzal/.m2/repository/com/google/code/geocoder-java/geocoder-java/0.16/geocoder-java-0.16.jar]
> 	at org.apache.karaf.features.internal.download.impl.SimpleDownloadTask.download(SimpleDownloadTask.java:90)[9:org.apache.karaf.features.core:4.0.4]
> 	at org.apache.karaf.features.internal.download.impl.AbstractRetryableDownloadTask.run(AbstractRetryableDownloadTask.java:58)[9:org.apache.karaf.features.core:4.0.4]
> 	... 7 more
> Caused by: java.net.MalformedURLException: Unknown protocol: wrap
> 	at java.net.URL.<init>(URL.java:620)[:1.8.0_66]
> 	at java.net.URL.<init>(URL.java:483)[:1.8.0_66]
> 	at java.net.URL.<init>(URL.java:432)[:1.8.0_66]
> 	at org.apache.karaf.features.internal.download.impl.SimpleDownloadTask.download(SimpleDownloadTask.java:62)[9:org.apache.karaf.features.core:4.0.4]
> 	... 8 more
> Caused by: java.lang.IllegalStateException: Unknown protocol: wrap
> 	at org.apache.felix.framework.URLHandlersStreamHandlerProxy.parseURL(URLHandlersStreamHandlerProxy.java:373)[org.apache.felix.framework-5.4.0.jar:]
> 	at java.net.URL.<init>(URL.java:615)[:1.8.0_66]
> 	... 11 more
> Caused by: java.io.IOException: Error downloading wrap:file:/Users/magonzal/.m2/repository/com/google/code/geocoder-java/geocoder-java/0.16/geocoder-java-0.16.jar
> 	at org.apache.karaf.features.internal.download.impl.AbstractRetryableDownloadTask.run(AbstractRetryableDownloadTask.java:67)[9:org.apache.karaf.features.core:4.0.4]
> 	at java.util.concurrent.Executors$RunnableAdapter.call(Executors.java:511)[:1.8.0_66]
> 	at java.util.concurrent.FutureTask.run(FutureTask.java:266)[:1.8.0_66]
> 	at java.util.concurrent.ScheduledThreadPoolExecutor$ScheduledFutureTask.access$201(ScheduledThreadPoolExecutor.java:180)[:1.8.0_66]
> 	at java.util.concurrent.ScheduledThreadPoolExecutor$ScheduledFutureTask.run(ScheduledThreadPoolExecutor.java:293)[:1.8.0_66]
> 	... 3 more
> Caused by: java.io.IOException: Could not download [wrap:file:/Users/magonzal/.m2/repository/com/google/code/geocoder-java/geocoder-java/0.16/geocoder-java-0.16.jar]
> 	at org.apache.karaf.features.internal.download.impl.SimpleDownloadTask.download(SimpleDownloadTask.java:90)[9:org.apache.karaf.features.core:4.0.4]
> 	at org.apache.karaf.features.internal.download.impl.AbstractRetryableDownloadTask.run(AbstractRetryableDownloadTask.java:58)[9:org.apache.karaf.features.core:4.0.4]
> 	... 7 more
> Caused by: java.net.MalformedURLException: Unknown protocol: wrap
> 	at java.net.URL.<init>(URL.java:620)[:1.8.0_66]
> 	at java.net.URL.<init>(URL.java:483)[:1.8.0_66]
> 	at java.net.URL.<init>(URL.java:432)[:1.8.0_66]
> 	at org.apache.karaf.features.internal.download.impl.SimpleDownloadTask.download(SimpleDownloadTask.java:62)[9:org.apache.karaf.features.core:4.0.4]
> 	... 8 more
> Caused by: java.lang.IllegalStateException: Unknown protocol: wrap
> 	at org.apache.felix.framework.URLHandlersStreamHandlerProxy.parseURL(URLHandlersStreamHandlerProxy.java:373)[org.apache.felix.framework-5.4.0.jar:]
> 	at java.net.URL.<init>(URL.java:615)[:1.8.0_66]
> 	... 11 more
> {code}
> Installing the feature from the karaf console works fine:
> {code:none}
> karaf@root()> feature:install camel-geocoder
> 233 | Active      |  50 | 0                   | wrap_file__Users_magonzal_.m2_repository_com_google_code_geocoder-java_geocoder-java_0.16_geocoder-java-0.16.jar
> {code}



--
This message was sent by Atlassian JIRA
(v6.3.4#6332)

Mime
View raw message